'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _node = require('./util/node');

var _node2 = _interopRequireDefault(_node);

var _returnvalue = require('./util/returnvalue');

var _returnvalue2 = _interopRequireDefault(_returnvalue);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Dom = function (_Node) {
    (0, _inherits3.default)(Dom, _Node);

    function Dom() {
        var _ref;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, Dom);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Dom.__proto__ || (0, _getPrototypeOf2.default)(Dom)).call.apply(_ref, [this].concat(args))), _this), _this.dep = ['chrome'], _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(Dom, [{
        key: 'exec',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(param, context) {
                var _this2 = this;

                var chrome, selector, doc, doms, nodes;
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                (0, _get3.default)(Dom.prototype.__proto__ || (0, _getPrototypeOf2.default)(Dom.prototype), 'exec', this).call(this, param, context);
                                chrome = context.getService('chrome');
                                selector = this.options.selector;
                                _context2.next = 5;
                                return chrome.DOM.getDocument();

                            case 5:
                                doc = _context2.sent;
                                _context2.next = 8;
                                return chrome.DOM.querySelectorAll({
                                    nodeId: doc.root.nodeId,
                                    selector: selector
                                });

                            case 8:
                                doms = _context2.sent;
                                _context2.next = 11;
                                return _promise2.default.all(doms.nodeIds.map(function () {
                                    var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(nodeId) {
                                        var ret;
                                        return _regenerator2.default.wrap(function _callee$(_context) {
                                            while (1) {
                                                switch (_context.prev = _context.next) {
                                                    case 0:
                                                        _context.next = 2;
                                                        return chrome.DOM.getAttributes({ nodeId: nodeId });

                                                    case 2:
                                                        ret = _context.sent;

                                                        // headless给的格式很奇葩
                                                        // 这里把['src', 'http://xxx', 'async', '']的格式转为
                                                        // {src: 'http://xxx', async: ''} 的格式
                                                        ret = _lodash.zipObject.apply(_this2, _lodash.zip.apply(_this2, (0, _lodash.chunk)(ret.attributes, 2)));
                                                        ret.nodeId = nodeId;
                                                        return _context.abrupt('return', ret);

                                                    case 6:
                                                    case 'end':
                                                        return _context.stop();
                                                }
                                            }
                                        }, _callee, _this2);
                                    }));

                                    return function (_x3) {
                                        return _ref3.apply(this, arguments);
                                    };
                                }()));

                            case 11:
                                nodes = _context2.sent;
                                return _context2.abrupt('return', new _returnvalue2.default(0, nodes, this));

                            case 13:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function exec(_x, _x2) {
                return _ref2.apply(this, arguments);
            }

            return exec;
        }()
    }]);
    return Dom;
}(_node2.default); /**
                    * @file dom node 用于在headless里查询某个特定的dom的node
                    * 
                    * @author liyinan
                    * @version 1.0
                    * @date 2017-07-23
                    */

Dom.type = 'dom';
Dom.declaration = {
    selector: {
        type: 'string'
    }
};
exports.default = Dom;