'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _node = require('./util/node');

var _node2 = _interopRequireDefault(_node);

var _returnvalue = require('./util/returnvalue');

var _returnvalue2 = _interopRequireDefault(_returnvalue);

var _continuousoutput = require('./util/continuousoutput');

var _continuousoutput2 = _interopRequireDefault(_continuousoutput);

var _koaRouter = require('koa-router');

var _koaRouter2 = _interopRequireDefault(_koaRouter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file hi node 用于接收hi消息
 * 
 * @author liyinan
 * @version 1.0
 * @date 2017-08-02
 */

var HttpInput = function (_Node) {
    (0, _inherits3.default)(HttpInput, _Node);

    function HttpInput() {
        var _ref;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, HttpInput);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = HttpInput.__proto__ || (0, _getPrototypeOf2.default)(HttpInput)).call.apply(_ref, [this].concat(args))), _this), _this.dep = ['koa'], _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(HttpInput, [{
        key: 'exec',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(param, context) {
                var _this2 = this;

                var node, continuousOutput, path, koa, router;
                return _regenerator2.default.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                (0, _get3.default)(HttpInput.prototype.__proto__ || (0, _getPrototypeOf2.default)(HttpInput.prototype), 'exec', this).call(this, param, context);

                                node = this;
                                continuousOutput = new _continuousoutput2.default();
                                path = this.options.path;
                                koa = context.getService('koa');
                                router = (0, _koaRouter2.default)();


                                router.all(path, function () {
                                    var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(ctx, next) {
                                        return _regenerator2.default.wrap(function _callee2$(_context2) {
                                            while (1) {
                                                switch (_context2.prev = _context2.next) {
                                                    case 0:
                                                        return _context2.abrupt('return', new _promise2.default(function (resolve) {
                                                            // 注册一个function
                                                            // 在后续http 的response响应后回到这里resolve
                                                            context.registerService('httpinput', function () {
                                                                var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(body) {
                                                                    return _regenerator2.default.wrap(function _callee$(_context) {
                                                                        while (1) {
                                                                            switch (_context.prev = _context.next) {
                                                                                case 0:
                                                                                    // 把http的response赋值给ctx
                                                                                    ctx.body = body;
                                                                                    // 返回http请求
                                                                                    _context.next = 3;
                                                                                    return next();

                                                                                case 3:
                                                                                    // 当前节点执行完毕
                                                                                    resolve();

                                                                                case 4:
                                                                                case 'end':
                                                                                    return _context.stop();
                                                                            }
                                                                        }
                                                                    }, _callee, _this2);
                                                                }));

                                                                return function (_x5) {
                                                                    return _ref4.apply(this, arguments);
                                                                };
                                                            }());
                                                            continuousOutput.output(new _returnvalue2.default(0, ctx, node));
                                                        }));

                                                    case 1:
                                                    case 'end':
                                                        return _context2.stop();
                                                }
                                            }
                                        }, _callee2, _this2);
                                    }));

                                    return function (_x3, _x4) {
                                        return _ref3.apply(this, arguments);
                                    };
                                }());

                                console.log('>>>>router<<<<', router);
                                koa.use(router.routes(), router.allowedMethods());

                                // return new ReturnValue(0, null, this);
                                return _context3.abrupt('return', continuousOutput);

                            case 10:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this);
            }));

            function exec(_x, _x2) {
                return _ref2.apply(this, arguments);
            }

            return exec;
        }()
    }]);
    return HttpInput;
}(_node2.default);

HttpInput.type = 'httpinput';
HttpInput.services = ['httpinput'];
exports.default = HttpInput;