'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _node = require('./util/node');

var _node2 = _interopRequireDefault(_node);

var _returnvalue = require('./util/returnvalue');

var _returnvalue2 = _interopRequireDefault(_returnvalue);

var _koa = require('koa');

var _koa2 = _interopRequireDefault(_koa);

var _koaBodyparser = require('koa-bodyparser');

var _koaBodyparser2 = _interopRequireDefault(_koaBodyparser);

var _http = require('http');

var _http2 = _interopRequireDefault(_http);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LaunchKoa = function (_Node) {
    (0, _inherits3.default)(LaunchKoa, _Node);

    function LaunchKoa() {
        var _ref;

        (0, _classCallCheck3.default)(this, LaunchKoa);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        // chromeInstance是为了运行时的，serialize的时候自然不需要被枚举
        var _this = (0, _possibleConstructorReturn3.default)(this, (_ref = LaunchKoa.__proto__ || (0, _getPrototypeOf2.default)(LaunchKoa)).call.apply(_ref, [this].concat(args)));

        Object.defineProperty(_this, 'koa', {
            emunerable: false,
            writable: true
        });
        return _this;
    }

    (0, _createClass3.default)(LaunchKoa, [{
        key: 'exec',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(param, context) {
                var _options$port, port, app;

                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                (0, _get3.default)(LaunchKoa.prototype.__proto__ || (0, _getPrototypeOf2.default)(LaunchKoa.prototype), 'exec', this).call(this, param, context);

                                _options$port = this.options.port, port = _options$port === undefined ? 3000 : _options$port;
                                app = new _koa2.default();

                                app.use((0, _koaBodyparser2.default)());

                                this.server = _http2.default.createServer(app.callback());
                                this.server.listen(port - 0);

                                context.registerService('koa', app);

                                return _context.abrupt('return', new _returnvalue2.default(0, null, this));

                            case 8:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function exec(_x, _x2) {
                return _ref2.apply(this, arguments);
            }

            return exec;
        }()

        /**
         * koa是个服务，不要销毁，不然其他node运行完就退出了
         *
         * @return {Promise}
         */

    }, {
        key: 'dispose',
        value: function () {
            var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
                var server;
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                _context2.next = 2;
                                return (0, _get3.default)(LaunchKoa.prototype.__proto__ || (0, _getPrototypeOf2.default)(LaunchKoa.prototype), 'dispose', this).call(this);

                            case 2:
                                server = this.server;
                                return _context2.abrupt('return', new _promise2.default(function (resolve, reject) {
                                    if (server) {
                                        server.close(function () {
                                            resolve();
                                        });
                                    } else {
                                        resolve();
                                    }
                                }));

                            case 4:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function dispose() {
                return _ref3.apply(this, arguments);
            }

            return dispose;
        }()
    }]);
    return LaunchKoa;
}(_node2.default); /**
                    * @file launch Koa2 node 用于启动koa2 server的node
                    * 
                    * @author liyinan
                    * @version 1.0
                    * @date 2017-08-2
                    */

LaunchKoa.type = 'launchkoa';
LaunchKoa.services = ['koa'];
LaunchKoa.declaration = {
    port: {
        type: 'string'
    }
};
exports.default = LaunchKoa;