'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _node = require('./util/node');

var _node2 = _interopRequireDefault(_node);

var _returnvalue = require('./util/returnvalue');

var _returnvalue2 = _interopRequireDefault(_returnvalue);

var _chromeRemoteInterface = require('chrome-remote-interface');

var _chromeRemoteInterface2 = _interopRequireDefault(_chromeRemoteInterface);

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file openpage node 用于在headless里打开页面的node
 * 
 * @author liyinan
 * @version 1.0
 * @date 2017-07-23
 */

var OpenPage = function (_Node) {
    (0, _inherits3.default)(OpenPage, _Node);

    function OpenPage() {
        (0, _classCallCheck3.default)(this, OpenPage);
        return (0, _possibleConstructorReturn3.default)(this, (OpenPage.__proto__ || (0, _getPrototypeOf2.default)(OpenPage)).apply(this, arguments));
    }

    (0, _createClass3.default)(OpenPage, [{
        key: 'exec',


        // 注册chrome的service
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(param, context) {
                var url, _options, signalname, _options$port, port, client, flow, signal, Page, Network, DOM, CSS;

                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                (0, _get3.default)(OpenPage.prototype.__proto__ || (0, _getPrototypeOf2.default)(OpenPage.prototype), 'exec', this).call(this, param, context);
                                url = param;
                                _options = this.options, signalname = _options.signalname, _options$port = _options.port, port = _options$port === undefined ? 9222 : _options$port;
                                _context.next = 5;
                                return (0, _chromeRemoteInterface2.default)({
                                    port: port
                                });

                            case 5:
                                client = _context.sent;
                                flow = this.context.flow;

                                flow.signal = flow.signal || new _events2.default();
                                signal = flow.signal;

                                this.client = client;
                                context.registerService('chrome', client);
                                Page = client.Page, Network = client.Network, DOM = client.DOM, CSS = client.CSS;

                                if (signalname) {
                                    // 监听网络请求
                                    Network.requestWillBeSent(function (params) {
                                        signal.emit(signalname, params);
                                    });
                                }
                                _context.next = 15;
                                return _promise2.default.all([DOM.enable(), Page.enable(), Network.enable(), CSS.enable()]);

                            case 15:
                                _context.next = 17;
                                return Page.navigate({ url: url });

                            case 17:
                                _context.next = 19;
                                return Page.loadEventFired();

                            case 19:
                                return _context.abrupt('return', new _returnvalue2.default(0, null, this));

                            case 20:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function exec(_x, _x2) {
                return _ref.apply(this, arguments);
            }

            return exec;
        }()
    }, {
        key: 'dispose',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                _context2.next = 2;
                                return (0, _get3.default)(OpenPage.prototype.__proto__ || (0, _getPrototypeOf2.default)(OpenPage.prototype), 'dispose', this).call(this);

                            case 2:
                                return _context2.abrupt('return', this.client && this.client.close());

                            case 3:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function dispose() {
                return _ref2.apply(this, arguments);
            }

            return dispose;
        }()
    }]);
    return OpenPage;
}(_node2.default);

OpenPage.type = 'openpage';
OpenPage.services = ['chrome'];
OpenPage.declaration = {
    port: {
        type: 'number'
    },
    signalname: {
        type: 'string'
    }
};
exports.default = OpenPage;