'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _flow = require('./flow');

var _flow2 = _interopRequireDefault(_flow);

var _returnvalue = require('./util/returnvalue');

var _returnvalue2 = _interopRequireDefault(_returnvalue);

var _util = require('./util/util');

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file subflow，subflow理应只有一个输出和多个输出
 * 如果业务存在多个输入的情况也应使用merge、wait等node合并为一个再输入
 * 多个输出应保持互斥，不会出现有两个输出的情况，这会导致无法计算subflow是否执行完毕
 * 
 * @author liyinan
 * @version 1.0
 * @date 2017-07-23
 */

var SubFlow = function (_Flow) {
    (0, _inherits3.default)(SubFlow, _Flow);

    function SubFlow(config) {
        (0, _classCallCheck3.default)(this, SubFlow);

        var _this = (0, _possibleConstructorReturn3.default)(this, (SubFlow.__proto__ || (0, _getPrototypeOf2.default)(SubFlow)).call(this, config));

        _this.options = {
            // 用于把subFlow的输入映射到某个node的输入
            // inMap的第一项为subflow的input的port 0，以此类推
            inMap: [],

            // 用于把subFlow的输出映射到某个node的输出
            // outMap的第一项为subflow的output的port 0，以此类推
            // example:
            // outMap = [{type: 'portmap', mapId: 'xxx', mapPort: '1'}]
            // 代表当id为xxx的node执行完，并且在这个node的port 1输出，则把这个结果映射到subflow的port 0(因为这个对象在outMap的第0个位置)
            // 不懂的问liyinan
            outMap: []
        };
        var _config$options = config.options,
            _config$options$inMap = _config$options.inMap,
            inMap = _config$options$inMap === undefined ? [] : _config$options$inMap,
            _config$options$outMa = _config$options.outMap,
            outMap = _config$options$outMa === undefined ? [] : _config$options$outMa;

        _this.in = inMap.length;
        _this.out = outMap.length;
        return _this;
    }

    (0, _createClass3.default)(SubFlow, [{
        key: 'buildDep',
        value: function buildDep() {
            this.dep = (0, _lodash.uniq)(this.nodes.reduce(function (all, node) {
                return all.concat(node.dep);
            }, []));
        }
    }, {
        key: 'getNodeById',
        value: function getNodeById(id) {
            return this.nodes.find(function (node) {
                return node.id === id;
            });
        }
    }, {
        key: 'exec',
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
                var _this2 = this;

                for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                    args[_key] = arguments[_key];
                }

                var context, _options, inMap, outMap, pairs, _ref2, port, data, node, outPort;

                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                context = args.pop();

                                this.trace.apply(this, ['exec: '].concat(args));

                                _options = this.options, inMap = _options.inMap, outMap = _options.outMap;

                                // 找到subflow的输入应该映射到内部的哪个node的哪个port，以此来确定subflow初始执行的节点

                                pairs = inMap.map(function (portMap, index) {
                                    return new _util.Pair(_this2.getNodeById(portMap.toId), args[index], portMap.toPort, context.clone());
                                });
                                // 执行subflow

                                _context.next = 6;
                                return (0, _util.asyncFlowRunner)(this, pairs, context);

                            case 6:
                                _ref2 = _context.sent;
                                port = _ref2.port;
                                data = _ref2.data;
                                node = _ref2.node;

                                // 找到当前执行结果应该映射到subflow 输出的哪个端口
                                outPort = outMap.findIndex(function (portMap) {
                                    return portMap.fromId === node.id && portMap.fromPort === port;
                                });
                                return _context.abrupt('return', new _returnvalue2.default(outPort, data, this));

                            case 12:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function exec() {
                return _ref.apply(this, arguments);
            }

            return exec;
        }()
    }]);
    return SubFlow;
}(_flow2.default);

SubFlow.type = 'subflow';
exports.default = SubFlow;